module Expri
  class MetricSet
    def metric(name, attributes={}, options={})
      @metrics << Metric.new(name, attributes, @options.merge(options))
    end

    def initialize(options={})
      @options = { :destroy_extras => true }.merge(options)
    end

    def run(&block)
      puts "run options=#{@options}" if @options[:verbose]
      cache_current

      @metrics = []
      instance_eval(&block)
      @metrics.each do |metric|
        metric.put
      end

      destroy_extras
    end

    private

    def cache_current
      @current_metrics = Metric.list
    end

    def destroy_extras
      extra_metrics = @current_metrics - @metrics.map(&:name)
      puts "check_extras extras=#{extra_metrics}" if @options[:verbose]
      if @options[:destroy_extras]
        extra_metrics.each do |metric|
          metric = Metric.new(metric, {}, @options)
          metric.destroy
        end
      end
    end
  end
end
